---
operationId: "createProjectBranchBucket"
method: "POST"
path: "/projects/{project_id}/branches/{branch_id}/buckets"
tag: "buckets"
stability: "beta"
interfaces: ["api", "sdk"]
---
> API Reference / Buckets / Create a bucket on the branch

## POST /projects/{project_id}/branches/{branch_id}/buckets

Creates a new branchable object-storage bucket on the specified branch.
Buckets are managed by the Neon Platform branchable-storage service.

**Note**: This endpoint is currently in Private Beta.


### Parameters

- `project_id` (string, path, required)
  The Neon project ID
- `branch_id` (string, path, required)
  The Neon branch ID

### Request body

- `name` (string, required)
  The bucket name.
- `access_level` (string, optional)
  Access level for the bucket. Defaults to `private`. Set to `public_read`
  to allow anonymous `GetObject`/`HeadObject` on objects in this bucket.
  
  Possible values: `private`, `public_read`
  Default: `private`

### Response (201)

- `bucket` (object, optional)
  - `name` (string, required)
    The bucket name (unique within a branch).
  - `access_level` (string, required)
    Controls anonymous access to objects in the bucket.
    - `private`: all reads and writes require authenticated requests (default).
    - `public_read`: anonymous `GetObject`/`HeadObject` requests succeed; listing,
      writes, and deletes still require authenticated requests.
    
    Possible values: `private`, `public_read`
  - `created_at` (string, required, format: date-time)
    When the bucket was created. For a bucket inherited from an
    ancestor branch this is the ancestor's creation time (the branch
    fork never re-creates the bucket).
    

### Code examples

```bash
curl "https://console.neon.tech/api/v2/projects/$PROJECT_ID/branches/$BRANCH_ID/buckets" \
  -X POST \
  -H "Authorization: Bearer $NEON_API_KEY"
```

```typescript
import { createNeonClient, raw } from '@neon/sdk';

const neon = createNeonClient({ apiKey: process.env.NEON_API_KEY });
const { data } = await raw.createProjectBranchBucket({
  client: neon.client,
  path: {
    project_id: process.env.PROJECT_ID,
    branch_id: process.env.BRANCH_ID
  }
});
```

### Errors

**410**
The project has been deleted
- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message

**default**
General Error.

The request may or may not be safe to retry, depending on the HTTP method, response status code,
and whether a response was received.

- If no response is returned from the API, a network error or timeout likely occurred.
- In some cases, the request may have reached the server and been successfully processed, but the response failed to reach the client. As a result, retrying non-idempotent requests can lead to unintended results.

The following HTTP methods are considered non-idempotent: `POST`, `PATCH`, `DELETE`, and `PUT`. Retrying these methods is generally **not safe**.
The following methods are considered idempotent: `GET`, `HEAD`, and `OPTIONS`. Retrying these methods is **safe** in the event of a network error or timeout.

Any request that returns a `503 Service Unavailable` response is always safe to retry.

Any request that returns a `423 Locked` response is safe to retry. `423 Locked` indicates that the resource is temporarily locked, for example, due to another operation in progress.

- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message
